#include "FaultFormation2.h"
#include "TerrainModif.h"
#include "make_FaceSet.h"
#include "buildings.h"
#include "GenTown.h"

#define MAX_X 128.f
#define MAX_Z 128.f
#define MAX_SUBURB 30.5f
#define MAX_SUBURB_SQUARE 15.f
#define MAX_CENTRE 13.5f
#define MAX_CENTRE_SQUARE 6.5f
#define RASTR 0.5f
#define MAX_BUILDING 34

// pomocne prom pro hledani vhodnych lokalit na mape
bool round;
float x_min;
float z_min;
float control_x,pom_x;
int count_round;

POSITION suburb, centre, between_streets, around_streets_in, around_streets_out;

// fce. vybira budovu podle zvolenych parametru
int select_building(int pre_building, float xb, float yb, float zb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
    // nejpresnejsi vyber 
	if(xb==get_param_building(building,1) && 
       zb==get_param_building(building,2) &&
	   yb==get_param_building(building,0)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// fce. vybira budovu podle max.velikosti podstavy
int select_building_by_max_down(int pre_building, float xb, float zb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
	if(xb>=get_param_building(building,1) && 
       zb>=get_param_building(building,2)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// fce. vybira budovu podle min.velikosti podstavy
int select_building_by_min_down(int pre_building, float xb, float zb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
	if(xb<=get_param_building(building,1) && 
       zb<=get_param_building(building,2)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// fce. vybira budovu podle min.velikosti podstavy
int select_building_by_min_high(int pre_building, float yb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
	if(yb<=get_param_building(building,0)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// fce. vybira budovu podle max.velikosti podstavy
int select_building_by_max_down_and_min_high(int pre_building, float xb, float yb, float zb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
	if(xb>=get_param_building(building,1) && 
       zb>=get_param_building(building,2) &&
	   yb<=get_param_building(building,0)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// fce. vybira budovu podle max.velikosti podstavy
int select_building_by_max_down_and_max_high(int pre_building, float xb, float yb, float zb) {
  int building=pre_building;
  int b;
  for(int i=0;i<35;i++) {
	if(building==34) building = 0;
	else building++;
	if(xb>=get_param_building(building,1) && 
       zb>=get_param_building(building,2) &&
	   yb>=get_param_building(building,0)) {
	   i=35;
	   b=building;
	}
	else b=100;
  }
  return b;
}

// postavi budovu na mapu
SoSeparator* put_building(TerrainPatch *tp,int building, float x, float z, float alfa) {

  SoSeparator* Building = new SoSeparator;

  float offset=0.f;
  float zoom=1.f;
  float x1=0.f;
  float x2=0.f;
  float z1=0.f;
  float z2=0.f;

  x1=x-zoom*get_param_building(building,1);
  z1=z-zoom*get_param_building(building,2);
  x2=x+zoom*get_param_building(building,1);
  z2=z+zoom*get_param_building(building,2);

  if(tp->getHeight(x,z) > tp->level.water && 
	 tp->getHeight(x,z) < tp->level.mountains) {

     float pos_x = x;
     float pos_z = z;
     float pos_y = modif( tp, 
                          tp->getIndex_x(x1-offset), tp->getIndex_y(z1-offset), 
	                      tp->getIndex_x(x2+offset), tp->getIndex_y(z2+offset), 
	                      alfa);

     Building -> addChild(make_FaceSet(building, 
                                       pos_x, pos_y, pos_z, 
		                               degree_to_radian(-alfa)));

	 }

  return(Building);
}


// fce.zjistuje zda dana oblast lezi(ve vhodne lok.) nad vodou a zaroven pod skaly
bool is_OK_area(TerrainPatch *tp,float max) {

  bool area=true;
  float x,z; 
  float xs=RASTR;
  float zs=RASTR;
  
  x=x_min;
  z=z_min;

  if(x_min+max>MAX_X) 
	area=false;
 
  while(x<x_min+max && x_min+max<=MAX_X && area) {
	if(control_x==x && count_round==1) {
	  round=true;
	  area=false;
    }
    while(z<z_min+max && z_min+max<=MAX_Z && area) {
	  if(tp->getHeight(x,z) < tp->level.water || 
		 tp->getHeight(x,z) > tp->level.mountains) {
		area=false;
        z_min=z+zs;
		}
	  else
    z+=zs;
	} // end while z
	z=z_min;
    x+=xs;
  } // end while x
  x=0.f;
  if(x_min+max>MAX_X) {
	count_round++;
	x_min=0.f;
    z_min=0.f;
  }
  if(z_min+max>MAX_Z) {
	x_min+=xs;
	z_min=0.f;
  }
  pom_x=x_min;

  return area;
}

// funkce prochazi mapu a snazi se nalezt vhodnou lokalitu pro centrum
bool find_suburb(TerrainPatch *tp,float maxx) {
  bool found=false;

  round=false;
  control_x=x_min;
  count_round=-1;

  pom_x=0.f;

  while(!found && !round) {
	if(is_OK_area(tp,maxx)) {
	  found=true;
  	  suburb.x_min=x_min;
	  suburb.z_min=z_min;
	  suburb.x_max=x_min+maxx;
	  suburb.z_max=z_min+maxx;       
	}
  }

  return found;
}

// fce.vytvori mestske centrum v kruhove formaci
SoSeparator* create_suburb(TerrainPatch *tp) {

  SoSeparator* Suburb = new SoSeparator;

  float alfa=45;
  int building=13;
  int end=5;
  float x=0;
  float z=0;
  float r=5;
  float center_x=suburb.x_min+(suburb.x_max-suburb.x_min)/2.f;
  float center_z=suburb.z_min+(suburb.z_max-suburb.z_min)/2.f;

  while(r<suburb.x_max-suburb.x_min) {
	for(int i=1;i<end;i++) {

	  building++;
      
	  switch(i){
	    case 1: x=center_x-r; z=center_z-r; break;
        case 2: x=center_x-r; z=center_z+r; break; 
        case 3: x=center_x+r; z=center_z-r; break;
        case 4: x=center_x+r; z=center_z+r; break;

	    case 5: x=center_x-r; z=center_z; break;
        case 6: x=center_x; z=center_z-r; break; 
        case 7: x=center_x+r; z=center_z; break;
        case 8: x=center_x; z=center_z+r; break;

	    case  9: x=center_x-r; z=center_z-r/2; break;
        case 10: x=center_x-r/2; z=center_z+r; break; 
        case 11: x=center_x+r; z=center_z-r/2; break;
        case 12: x=center_x+r/2; z=center_z+r; break;

	    case 13: x=center_x-r/2; z=center_z-r; break;
        case 14: x=center_x-r; z=center_z+r/2; break; 
        case 15: x=center_x+r/2; z=center_z-r; break;
        case 16: x=center_x+r; z=center_z+r/2; break;
      }


	  switch(end) {
	    case 5: 
		 // building = select_building_by_min_high(building,3.5f); 
		 // alfa+=10; 
		break;

		case 9: 
		 // if(building%2==0) select_building_by_min_high(building,2.f); 
		 // else building = select_building_by_min_high(building,2.5f);
		 // alfa+=20; 
		break;

		case 13: 
		  //if(building%2==0) building = select_building_by_min_down(building,1.f,1.f); 
		  //else building = select_building_by_min_down(building,0.5f,0.5f);
		  //alfa+=30; 
		  building = select_building_by_min_down(building,0.5f,0.5f);
		break;


	  }

      alfa+=10;
	  if(alfa>80) alfa = 0;

	  if(x>suburb.x_min && x<suburb.x_max && z>suburb.z_min && z<suburb.z_max)
          Suburb -> addChild(put_building(tp,building,x,z,alfa));
    }
	if(end==17) end=17;
	else end+=4;

    if(end==5) r+=3.f;
	else r+=5.f;
   
  } 

  return(Suburb);
}


// funkce prochazi mapu a snazi se nalezt vhodnou lokalitu pro centrum
bool find_centre(TerrainPatch *tp, float maxx) {
  bool found=false;

  round=false;
  control_x=x_min;
  count_round=-1;

  pom_x=0.f;

  while(!found && !round) {
	if(is_OK_area(tp,maxx)) {
	  found=true;
  	  centre.x_min=x_min;
	  centre.z_min=z_min;
	  centre.x_max=x_min+maxx;
	  centre.z_max=z_min+maxx;       
	}
  }
  if(centre.x_max>suburb.x_min && 
     centre.z_max>suburb.z_min &&
     centre.x_min<suburb.x_max && 
     centre.z_min<suburb.z_max)
     found=false;

  return found;
}

// fce.vytvori mestske centrum v kruhove formaci
SoSeparator* create_centre(TerrainPatch *tp,POSITION centre) {

  SoSeparator* Centre = new SoSeparator;

  float alfa=45;
  int building=0;
  int end=5;
  float x=0;
  float z=0;
  float r=1.5;
  float center_x=centre.x_min+(centre.x_max-centre.x_min)/2.f;
  float center_z=centre.z_min+(centre.z_max-centre.z_min)/2.f;

  while(r<centre.x_max-centre.x_min) {
	for(int i=1;i<end;i++) {

	  //building = select_building_by_max_down(building,0.5f,0.5f);
      
	  switch(i){
	    case 1: x=center_x-r; z=center_z-r; break;
        case 2: x=center_x-r; z=center_z+r; break; 
        case 3: x=center_x+r; z=center_z-r; break;
        case 4: x=center_x+r; z=center_z+r; break;

	    case 5: x=center_x-r; z=center_z; break;
        case 6: x=center_x; z=center_z-r; break; 
        case 7: x=center_x+r; z=center_z; break;
        case 8: x=center_x; z=center_z+r; break;

	    case  9: x=center_x-r; z=center_z-r/2; break;
        case 10: x=center_x-r/2; z=center_z+r; break; 
        case 11: x=center_x+r; z=center_z-r/2; break;
        case 12: x=center_x+r/2; z=center_z+r; break;

	    case 13: x=center_x-r/2; z=center_z-r; break;
        case 14: x=center_x-r; z=center_z+r/2; break; 
        case 15: x=center_x+r/2; z=center_z-r; break;
        case 16: x=center_x+r; z=center_z+r/2; break;
      }


	  switch(end) {
	    case 5: 
		 building = select_building_by_max_down_and_min_high(building,0.5f,3.f,0.5f);
		 // alfa+=10; 
		break;

		case 9: 
		 building = select_building_by_max_down_and_min_high(building,0.5f,2.f,0.5f);
		 // if(building%2==0) select_building_by_min_high(building,2.f); 
		 // else building = select_building_by_min_high(building,2.5f);
		 // alfa+=20; 
		break;

		case 13:
		  building = select_building_by_max_down_and_max_high(building,0.5f,2.f,0.5f);
		  //if(building%2==0) building = select_building_by_min_down(building,1.f,1.f); 
		  //else building = select_building_by_min_down(building,0.5f,0.5f);
		  //alfa+=30; 
		  //building = select_building_by_min_down(building,0.5f,0.5f);
		break;

	  }

      alfa+=10;
	  if(alfa>80) alfa = 0;

	  if(x>centre.x_min && x<centre.x_max && 
		 z>centre.z_min && z<centre.z_max)
          Centre -> addChild(put_building(tp,building,x,z,alfa));
    }
	if(end==17) end=17;
	else end+=4;

    if(end==5) r+=2.f;
	else r+=2.f;
    
  } 

  return(Centre);
}


// fce.vytvori zastavbu mezi mestskym centrum a ctvrti
SoSeparator* create_between_streets(TerrainPatch *tp,POSITION between_streets) {

  SoSeparator* Between_streets = new SoSeparator;

  int x1=(int)between_streets.x_min;
  int z1=(int)between_streets.z_min;
  int x2=(int)between_streets.x_max;
  int z2=(int)between_streets.z_max;

  int building=0;
  int count_building=0;
  float bs_alfa = 0.f;
  bool is_in_suburb=true;
  bool is_in_centre=true;
  bool is_in_between=true;

  for(int x=x1; x<x2; x+=3)
	for(int z=z1; z<z2 ; z+=3) {

	  if(x>centre.x_min && x<centre.x_max && 
		 z>centre.z_min && z<centre.z_max)
         is_in_centre=true;
	  else
		 is_in_centre=false;

	  if(x>suburb.x_min && x<suburb.x_max && 
		 z>suburb.z_min && z<suburb.z_max)
         is_in_suburb=true;
      else
		 is_in_suburb=false;

      if(x>between_streets.x_min && x<between_streets.x_max && 
	     z>between_streets.z_min && z<between_streets.z_max)
		 is_in_between=true;
	  else
		 is_in_between=false;

	  if(is_in_between && !is_in_centre && !is_in_suburb) {
         Between_streets -> addChild(put_building(tp,building,(float)x,(float)z,bs_alfa));
	  }

	  building++;
	  bs_alfa +=20.f;
	  if(bs_alfa>80) bs_alfa = 10.f;

	}


  return(Between_streets);

}



// fce.vytvori zastavbu mezi mestskym centrum a ctvrti
SoSeparator* create_around_streets(TerrainPatch *tp,
						 POSITION around_streets_in,POSITION around_streets_out) {

  SoSeparator* Around_streets = new SoSeparator;

  int x1=(int)around_streets_out.x_min;
  int z1=(int)around_streets_out.z_min;
  int x2=(int)around_streets_out.x_max;
  int z2=(int)around_streets_out.z_max;

  int building=0;
  int count_building=0;
  float as_alfa = 0.f;
  float r;
  float sx=(x2-x1)/2.f;
  float sz=(z2-z1)/2.f;
  float lx;
  float lz;
  if(x2-x1 <= z2-z1) r=(x2-x1)/2.f;
  else r=(z2-z1)/2.f;
  int zs;

  for(int x=x1; x<x2; x+=zs)
	for(int z=z1; z<z2 ; z+=zs) {

	  if(x<=sx) lx=sx-x;
	  else lx=x-sx;

	  if(z<=sz) lz=sz-z;
	  else lz=z-sx;

	  if(!(x>around_streets_in.x_min && x<around_streets_in.x_max && 
		   z>around_streets_in.z_min && z<around_streets_in.z_max) &&		  
		  (x>around_streets_out.x_min && x<around_streets_out.x_max && 
		   z>around_streets_out.z_min && z<around_streets_out.z_max))
		   if(x>sx-10 || x<sx+10 || z>sz-10 || z<sz+10 ) {
             // vykarajuji stredy mensi kruznici
             if( (lx*lx) + (lz*lz) < (r*r)-400.f )
           
		 Around_streets -> addChild(put_building(tp,building,(float)x,(float)z,as_alfa));

		   }
		   
           else { 
		     // zaobluji rohy vetsi krouznici
		     if( (lx*lx) + (lz*lz) < (r*r) )

          Around_streets -> addChild(put_building(tp,building,(float)x,(float)z,as_alfa));

		   }

	  zs=(int)get_param_building(building,2)+6;
	  building = select_building_by_max_down_and_max_high(building,4.f,1.5f,4.f);;
	  //if(count_building==2) { count_building=0; bs_alfa +=30.f;}
	  as_alfa +=20.f;
	  if(as_alfa>80) as_alfa = 10.f;
	}

  return(Around_streets);

}




// fce.generuje virtualni mestskou zastavbu
SoSeparator* GenerTown(TerrainPatch *tp) {

  // uzel do ktereho se generuje mesto
  SoSeparator* town = new SoSeparator;

  // pozice od ktere se hleda lokalita pro umisteni centra mesta
  x_min=MAX_X/2;
  z_min=MAX_Z/2;
  bool f_suburb = false;

  if(find_suburb(tp,MAX_SUBURB)) {

	f_suburb=true;

	// v prostred centra si to vytvorime male namesti
    float high_square_suburb =
    modif( tp, 
           tp->getIndex_x(suburb.x_min + MAX_SUBURB_SQUARE), 
		   tp->getIndex_y(suburb.z_min + MAX_SUBURB_SQUARE), 
	       tp->getIndex_x(suburb.x_max - MAX_SUBURB_SQUARE), 
		   tp->getIndex_y(suburb.z_max - MAX_SUBURB_SQUARE), 
	       0.f);

    town -> addChild(create_suburb(tp));

    printf("Suburb found: ");
    printf("%f %f %f %f \n",suburb.x_min,suburb.z_min,suburb.x_max,suburb.z_max);
	printf("high_square_suburb = %f \n",high_square_suburb);
  }
  else 
    printf("Suburb NOT found: \n");



  // pozice od ktere se hleda lokalita pro umisteni ctvrti mesta
  x_min=MAX_X/4;
  z_min=MAX_Z/4;

  bool f_centre =false;

  if(find_centre(tp,MAX_CENTRE)) {

	f_centre =true;

    float high_square_centre = 
	modif( tp, 
           tp->getIndex_x(centre.x_min + MAX_CENTRE_SQUARE), 
		   tp->getIndex_y(centre.z_min + MAX_CENTRE_SQUARE), 
	       tp->getIndex_x(centre.x_max - MAX_CENTRE_SQUARE), 
		   tp->getIndex_y(centre.z_max - MAX_CENTRE_SQUARE), 
	       0.f);

	printf("high_square_centre = %f \n",high_square_centre);

    town -> addChild(create_centre(tp,centre));

    printf("Centre found: ");
    printf("%f %f %f %f \n", centre.x_min, centre.z_min,
		                     centre.x_max, centre.z_max);
	printf("high_square_centre = %f \n",high_square_centre);
  }
  else 
    printf("centre NOT found: \n");



  bool f_between_streets=false;

  // vyplneni prostoru mezi centrem a predmestim
  if(f_suburb && f_centre) {

    f_between_streets=true;

    if(suburb.x_min < centre.x_min) between_streets.x_min = suburb.x_min;
    else between_streets.x_min = centre.x_min;

    if(suburb.z_min < centre.z_min) between_streets.z_min = suburb.z_min;
    else between_streets.z_min = centre.z_min;

    if(suburb.x_max > centre.x_max) between_streets.x_max = suburb.x_max;
    else between_streets.x_max = centre.x_max;

    if(suburb.z_max > centre.z_max) between_streets.z_max = suburb.z_max;
    else between_streets.z_max = centre.z_max;

    town -> addChild(create_between_streets(tp,between_streets));

    printf("Between_streets found: ");
    printf("%f %f %f %f \n", between_streets.x_min, between_streets.z_min,
		                     between_streets.x_max, between_streets.z_max);
  }
  else 
    printf("Between_streets NOT found: \n");

  // vyplneni okoli mesta
  if(f_suburb || f_centre || f_between_streets) {

	 if(f_between_streets) {
	    around_streets_in.x_min = between_streets.x_min;
		around_streets_in.z_min = between_streets.z_min;
		around_streets_in.x_max = between_streets.x_max;
		around_streets_in.z_max = between_streets.z_max;
	 }
	 else if(f_centre) {
	    around_streets_in.x_min = centre.x_min;
		around_streets_in.z_min = centre.z_min;
		around_streets_in.x_max = centre.x_max;
		around_streets_in.z_max = centre.z_max;
     } 
	 else if(f_suburb) {
	    around_streets_in.x_min = suburb.x_min;
		around_streets_in.z_min = suburb.z_min;
		around_streets_in.x_max = suburb.x_max;
		around_streets_in.z_max = suburb.z_max;
	 }

     float around = 35.f;

	 if(around_streets_in.x_min-around < 0.f) around_streets_out.x_min=0.f;
	 else around_streets_out.x_min=around_streets_in.x_min-around;

	 if(around_streets_in.z_min-around < 0.f) around_streets_out.z_min=0.f;
	 else around_streets_out.z_min=around_streets_in.z_min-around;

	 if(around_streets_in.x_max+around > MAX_X) around_streets_out.x_max=MAX_X;
	 else around_streets_out.x_max=around_streets_in.x_max+around;

	 if(around_streets_in.z_max+around > MAX_Z) around_streets_out.z_max=MAX_Z;
	 else around_streets_out.z_max=around_streets_in.z_max+around;

    town -> addChild(create_around_streets(tp,around_streets_in,around_streets_out));

    printf("Around_streets found: \n");
    printf("in: %f %f %f %f \n", around_streets_in.x_min, around_streets_in.z_min,
		                         around_streets_in.x_max, around_streets_in.z_max);
    printf("out: %f %f %f %f \n", around_streets_out.x_min, around_streets_out.z_min,
		                          around_streets_out.x_max, around_streets_out.z_max);
  }
  else 
    printf("Around_streets NOT found: \n");


  return(town);
}   

