//* ----------------------------------------------------------------------------
//*
//* THIS SOFTWARE IS NOT COPYRIGHTED EXCEPT FaultFormatin2
//* lisence of FaultFormatin2 you can find on
//* http://www.root.cz/clanky/open-inventor-terrain-generator-2/
//*
//* This source code is offered for use in the public domain.
//* You may use, modify or distribute it freely.
//*
//* This source code is distributed in the hope that it will be useful but
//* WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
//* DISCLAIMED.  This includes but is not limited to warranties of
//* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//*
//* If you find the source code useful, authors will kindly welcome
//* if you give them credit and keep their names with their source code,
//* but do not feel to be forced to do so.
//*
//\*****************************************************************************/



//
// Implementace main funkce pro Windows.
// Pouv knihovnu SoWin.
//


#include <stdio.h>
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/Win/viewers/SoWinViewer.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/events/SoKeyboardEvent.h> 
#include <Inventor/nodes/SoEventCallback.h> 
#include "keyboard.h"


// Pro linker: Budeme linkovat s main,
// nikoliv WinMain, jak je na Windows zvykem,
// a aplikace bude vyuvat konzoli.
#pragma comment(linker, "/entry:\"mainCRTStartup\"")
#pragma comment(linker, "/subsystem:\"console\"")


extern SoSeparator *createBuild(int argc, char **argv);
extern SoSeparator *createGener(int argc, char **argv);
extern const char *appTitle;
extern bool headlight;

int main(int argc, char **argv)
{
  // Inicializuj Inventor
  HWND window = SoWin::init(argv[0]);
  if (window == NULL) exit(1);

  // 
  int c = 0;
  while(c==0) {
    printf("\n");
    printf("\tProhlizeni budov mestske zastavby........1\n");
    printf("\tGenerovani virtualni mestske zastavby....2\n");
    printf("\tVase volba: ");
    c = getchar();
    if(c!='1' && c!='2') {
	  printf("\n\tCti poradne :) \n");
	  c = getchar(); // ENTER mi to zere 
 	  c=0;
	}
  }

  if(c == '1') {
    printf("\n\tPripravuji prohlizec budov.\n");
    // Vytvo koen scny
    SoSeparator *root = new SoSeparator;
    root->ref();
    SoSeparator *buildings = new SoSeparator();
    root->addChild(buildings);
    buildings->addChild(createBuild(argc, argv));

    // root->addKeyboard
    // Obsluha klavesnice
    SoEventCallback * cb = new SoEventCallback;
    cb->addEventCallback(SoKeyboardEvent::getClassTypeId(), myEventCB, buildings);
    root->insertChild(cb, 0);

    // Vytvo okno prohlee
    SoWinExaminerViewer *viewer = new SoWinExaminerViewer(window);
    viewer->setSceneGraph(root);
    //viewer->setFullScreen(true);
    viewer->setViewing(false);
    viewer->setCursorEnabled(true);
    //viewer->setHeadlight(headlightb);
    viewer->setTitle("Buildings Viewer");
    viewer->show();
    //viewer->setViewing(true);

    // Zobraz okna a rozje renderovac smyku
    SoWin::show(window);
    SoWin::mainLoop();

    // Uvolni pam
    delete viewer;
    root->unref();
  }

  else {
    printf("\n\tGeneruji virtualni mestskou zastavbu. \n");
    // Vytvo koen scny
    SoSeparator *root = createGener(argc, argv);
    root->ref();

    // Vytvo okno prohlee
    SoWinExaminerViewer *viewer = new SoWinExaminerViewer(window);
    viewer->setSceneGraph(root);
    viewer->setHeadlight(headlight);
    viewer->setTitle(appTitle);
//	viewer->DrawType(STILL);
//	viewer->setDrawStyle(VIEW_NO_TEXTURE);
    viewer->show();

    // Zobraz okna a rozje renderovac smyku
    SoWin::show(window);
    SoWin::mainLoop();

    // Uvolni pam
    delete viewer;
    root->unref();
  }

  return 0;
}
