#include"buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 

static float p00_vertices[][3] = {
	-0.5f, 0, -0.5f,  // 0
	 0.5f, 0, -0.5f,  // 1
    -0.5f, 1, -0.5f,  // 2
     0.5f, 1, -0.5f,  // 3

	-0.5f, 0, 0.5f,  // 4
     0.5f, 0, 0.5f,  // 5
    -0.5f, 1, 0.5f,  // 6
     0.5f, 1, 0.5f   // 7
};


// NORMALS
// normaly pro dobre osvetleni sten modelu budovy

static float p00_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z
	
};

static int32_t p00_indices_front[] = {0,1,2,3, -1};
static int32_t p00_indices_left[] = {0,2,4,6, -1};
static int32_t p00_indices_right[] = {1,3,5,7, -1};
static int32_t p00_indices_back[] = {4,5,6,7, -1};
static int32_t p00_indices_up[] = {2,3,6,7, -1};
static int32_t p00_indices_bottom[] = {0,1,4,5, -1};

static int normalIndex_p00_front[] = {5,5};   // -z     
static int normalIndex_p00_left[] = {3,3};    // -x
static int normalIndex_p00_right[] = {0,0};   //  x
static int normalIndex_p00_back[] = {2,2};    //  z
static int normalIndex_p00_up[] = {1,1};      //  y  
static int normalIndex_p00_bottom[] = {4,4};  // -y

static int32_t TexCoordIndex_p00_front[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p00_up[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p00_left[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p00_right[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p00_back[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p00_bottom[] = {0,1,2,3, -1};

// PANELAK 1
// krychle ( cube pres FaceSet :) ) 
SoSeparator *make_p00_FaceSet(float x, float y, float z, float alfa)
{
  // 
  SoSeparator *p00 = new SoSeparator;
  p00 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  p00->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  p00->addChild(scale);

  // rotace modelu budovy 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  p00 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, p00_normal);
  p00 -> addChild(myNormals); 

  // 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  p00 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(p00_vertices)/sizeof(float), p00_vertices);
  p00->addChild(coords);

  // 'vyrez textury (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  p00->addChild(texCoord);

  // front
  SoTexture2 *texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_p00_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_front)/sizeof(int32_t), p00_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_front)/sizeof(int), normalIndex_p00_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_front)/sizeof(int32_t), TexCoordIndex_p00_front); 
  p00->addChild(stripSet);


  // up
  texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_p00_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_up)/sizeof(int32_t), p00_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_up)/sizeof(int), normalIndex_p00_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_up)/sizeof(int32_t), TexCoordIndex_p00_up); 
  p00->addChild(stripSet);


  // left
  texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_p00_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_left)/sizeof(int32_t), p00_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_left)/sizeof(int), normalIndex_p00_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_left)/sizeof(int32_t), TexCoordIndex_p00_left); 
  p00->addChild(stripSet);


  // right
  texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_p00_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_right)/sizeof(int32_t), p00_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_right)/sizeof(int), normalIndex_p00_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_right)/sizeof(int32_t), TexCoordIndex_p00_right); 
  p00->addChild(stripSet);

  
  // back
  texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_p00_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_back)/sizeof(int32_t), p00_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_back)/sizeof(int), normalIndex_p00_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_back)/sizeof(int32_t), TexCoordIndex_p00_back); 
  p00->addChild(stripSet);


  // bottom
  texture_p00 = new SoTexture2;
  p00 -> addChild(texture_p00);
  texture_p00 -> filename.setValue("Texture/p00/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p00_indices_bottom)/sizeof(int32_t), p00_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p00_bottom)/sizeof(int), normalIndex_p00_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p00_bottom)/sizeof(int32_t), TexCoordIndex_p00_bottom); 
  p00->addChild(stripSet);

  p00 -> unrefNoDelete();

  return p00;
}
// end PANELAK 1