#include"buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 

static float p01_vertices[][3] = {
	-1, 0, -0.5f,  // 0
	 1, 0, -0.5f,  // 1
    -1, 1, -0.5f,  // 2
     1, 1, -0.5f,  // 3

	-1, 0, 0.5f,  // 4
     1, 0, 0.5f,  // 5
    -1, 1, 0.5f,  // 6
     1, 1, 0.5f   // 7
};

// NORMALS
// normaly pro dobre osvetleni sten modelu budovy

static float p01_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z
	
};

static int32_t p01_indices_front[] = {0,1,2,3, -1};
static int32_t p01_indices_left[] = {0,2,4,6, -1};
static int32_t p01_indices_right[] = {1,3,5,7, -1};
static int32_t p01_indices_back[] = {4,5,6,7, -1};
static int32_t p01_indices_up[] = {2,3,6,7, -1};
static int32_t p01_indices_bottom[] = {0,1,4,5, -1};

static int normalIndex_p01_front[] = {5,5};   // -z     
static int normalIndex_p01_left[] = {3,3};    // -x
static int normalIndex_p01_right[] = {0,0};   //  x
static int normalIndex_p01_back[] = {2,2};    //  z
static int normalIndex_p01_up[] = {1,1};      //  y  
static int normalIndex_p01_bottom[] = {4,4};  // -y

static int32_t TexCoordIndex_p01_front[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p01_up[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p01_left[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p01_right[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p01_back[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p01_bottom[] = {0,1,2,3, -1};


// PANELAK 2
// cube scale v ose x o 2 
SoSeparator *make_p01_FaceSet(float x, float y, float z, float alfa)
{
  //
  SoSeparator *p01 = new SoSeparator;
  p01 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  p01->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  p01->addChild(scale);

  // rotace modelu budovy 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  p01 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, p01_normal);
  p01 -> addChild(myNormals); 

  // 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  p01 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(p01_vertices)/sizeof(float), p01_vertices);
  p01->addChild(coords);

  // 'vyrez textury (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  p01->addChild(texCoord);

  // front
  SoTexture2 *texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_p01_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_front)/sizeof(int32_t), p01_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_front)/sizeof(int), normalIndex_p01_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_front)/sizeof(int32_t), TexCoordIndex_p01_front); 
  p01->addChild(stripSet);


  // up
  texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_p01_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_up)/sizeof(int32_t), p01_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_up)/sizeof(int), normalIndex_p01_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_up)/sizeof(int32_t), TexCoordIndex_p01_up); 
  p01->addChild(stripSet);


  // left
  texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_p01_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_left)/sizeof(int32_t), p01_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_left)/sizeof(int), normalIndex_p01_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_left)/sizeof(int32_t), TexCoordIndex_p01_left); 
  p01->addChild(stripSet);


  // right
  texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_p01_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_right)/sizeof(int32_t), p01_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_right)/sizeof(int), normalIndex_p01_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_right)/sizeof(int32_t), TexCoordIndex_p01_right); 
  p01->addChild(stripSet);

  
  // back
  texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_p01_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_back)/sizeof(int32_t), p01_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_back)/sizeof(int), normalIndex_p01_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_back)/sizeof(int32_t), TexCoordIndex_p01_back); 
  p01->addChild(stripSet);


  // bottom
  texture_p01 = new SoTexture2;
  p01 -> addChild(texture_p01);
  texture_p01 -> filename.setValue("Texture/p01/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p01_indices_bottom)/sizeof(int32_t), p01_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p01_bottom)/sizeof(int), normalIndex_p01_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p01_bottom)/sizeof(int32_t), TexCoordIndex_p01_bottom); 
  p01->addChild(stripSet);

  p01 -> unrefNoDelete();

  return p01;
} 
// end PANELAK 2
