#include"buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 

static float p02_vertices[][3] = {
	-1.5f, 0, -0.5f,  // 0
	 1.5f, 0, -0.5f,  // 1
    -1.5f, 1, -0.5f,  // 2
     1.5f, 1, -0.5f,  // 3

	-1.5f, 0, 0.5f,  // 4
     1.5f, 0, 0.5f,  // 5
    -1.5f, 1, 0.5f,  // 6
     1.5f, 1, 0.5f   // 7
};


// NORMALS
// normaly pro dobre osvetleni sten modelu budovy

static float p02_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z
	
};

static int32_t p02_indices_front[] = {0,1,2,3, -1};
static int32_t p02_indices_left[] = {0,2,4,6, -1};
static int32_t p02_indices_right[] = {1,3,5,7, -1};
static int32_t p02_indices_back[] = {4,5,6,7, -1};
static int32_t p02_indices_up[] = {2,3,6,7, -1};
static int32_t p02_indices_bottom[] = {0,1,4,5, -1};

static int normalIndex_p02_front[] = {5,5};   // -z     
static int normalIndex_p02_left[] = {3,3};    // -x
static int normalIndex_p02_right[] = {0,0};   //  x
static int normalIndex_p02_back[] = {2,2};    //  z
static int normalIndex_p02_up[] = {1,1};      //  y  
static int normalIndex_p02_bottom[] = {4,4};  // -y

static int32_t TexCoordIndex_p02_front[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p02_up[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p02_left[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p02_right[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p02_back[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p02_bottom[] = {0,1,2,3, -1};


// PANELAK 3
// cube scale v ose x o 3 
SoSeparator *make_p02_FaceSet(float x, float y, float z, float alfa)
{
  //
  SoSeparator *p02 = new SoSeparator;
  p02 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  p02->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  p02->addChild(scale);

  // rotace modelu budovy 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  p02 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, p02_normal);
  p02 -> addChild(myNormals); 

  // 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  p02 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(p02_vertices)/sizeof(float), p02_vertices);
  p02->addChild(coords);

  // 'vyrez textury (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  p02->addChild(texCoord);

  // front
  SoTexture2 *texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_p02_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_front)/sizeof(int32_t), p02_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_front)/sizeof(int), normalIndex_p02_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_front)/sizeof(int32_t), TexCoordIndex_p02_front); 
  p02->addChild(stripSet);


  // up
  texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_p02_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_up)/sizeof(int32_t), p02_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_up)/sizeof(int), normalIndex_p02_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_up)/sizeof(int32_t), TexCoordIndex_p02_up); 
  p02->addChild(stripSet);


  // left
  texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_p02_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_left)/sizeof(int32_t), p02_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_left)/sizeof(int), normalIndex_p02_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_left)/sizeof(int32_t), TexCoordIndex_p02_left); 
  p02->addChild(stripSet);


  // right
  texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_p02_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_right)/sizeof(int32_t), p02_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_right)/sizeof(int), normalIndex_p02_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_right)/sizeof(int32_t), TexCoordIndex_p02_right); 
  p02->addChild(stripSet);

  
  // back
  texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_p02_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_back)/sizeof(int32_t), p02_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_back)/sizeof(int), normalIndex_p02_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_back)/sizeof(int32_t), TexCoordIndex_p02_back); 
  p02->addChild(stripSet);


  // bottom
  texture_p02 = new SoTexture2;
  p02 -> addChild(texture_p02);
  texture_p02 -> filename.setValue("Texture/p02/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p02_indices_bottom)/sizeof(int32_t), p02_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p02_bottom)/sizeof(int), normalIndex_p02_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p02_bottom)/sizeof(int32_t), TexCoordIndex_p02_bottom); 
  p02->addChild(stripSet);

  p02 -> unrefNoDelete();

  return p02;
} 
// end PANELAK 3