#include"buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 

static float p08_vertices[][3] = {
	-1, 0, -0.5f,  // 0
	 1, 0, -0.5f,  // 1
    -1, 3, -0.5f,  // 2
     1, 3, -0.5f,  // 3

	-1, 0, 0.5f,  // 4
     1, 0, 0.5f,  // 5
    -1, 3, 0.5f,  // 6
     1, 3, 0.5f   // 7
};


// NORMALS
// normaly pro dobre osvetleni sten modelu budovy

static float p08_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z
	
};

static int32_t p08_indices_front[] = {0,1,2,3, -1};
static int32_t p08_indices_left[] = {0,2,4,6, -1};
static int32_t p08_indices_right[] = {1,3,5,7, -1};
static int32_t p08_indices_back[] = {4,5,6,7, -1};
static int32_t p08_indices_up[] = {2,3,6,7, -1};
static int32_t p08_indices_bottom[] = {0,1,4,5, -1};

static int normalIndex_p08_front[] = {5,5};   // -z     
static int normalIndex_p08_left[] = {3,3};    // -x
static int normalIndex_p08_right[] = {0,0};   //  x
static int normalIndex_p08_back[] = {2,2};    //  z
static int normalIndex_p08_up[] = {1,1};      //  y  
static int normalIndex_p08_bottom[] = {4,4};  // -y

static int32_t TexCoordIndex_p08_front[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p08_up[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p08_left[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p08_right[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p08_back[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p08_bottom[] = {0,1,2,3, -1};

// PANELAK 1
// krychle ( cube pres FaceSet :) ) 
SoSeparator *make_p08_FaceSet(float x, float y, float z, float alfa)
{
  // 
  SoSeparator *p08 = new SoSeparator;
  p08 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  p08->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  p08->addChild(scale);

  // rotace modelu budovy 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  p08 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, p08_normal);
  p08 -> addChild(myNormals); 

  // 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  p08 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(p08_vertices)/sizeof(float), p08_vertices);
  p08->addChild(coords);

  // 'vyrez textury (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  p08->addChild(texCoord);

  // front
  SoTexture2 *texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_p08_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_front)/sizeof(int32_t), p08_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_front)/sizeof(int), normalIndex_p08_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_front)/sizeof(int32_t), TexCoordIndex_p08_front); 
  p08->addChild(stripSet);


  // up
  texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_p08_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_up)/sizeof(int32_t), p08_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_up)/sizeof(int), normalIndex_p08_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_up)/sizeof(int32_t), TexCoordIndex_p08_up); 
  p08->addChild(stripSet);


  // left
  texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_p08_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_left)/sizeof(int32_t), p08_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_left)/sizeof(int), normalIndex_p08_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_left)/sizeof(int32_t), TexCoordIndex_p08_left); 
  p08->addChild(stripSet);


  // right
  texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_p08_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_right)/sizeof(int32_t), p08_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_right)/sizeof(int), normalIndex_p08_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_right)/sizeof(int32_t), TexCoordIndex_p08_right); 
  p08->addChild(stripSet);

  
  // back
  texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_p08_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_back)/sizeof(int32_t), p08_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_back)/sizeof(int), normalIndex_p08_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_back)/sizeof(int32_t), TexCoordIndex_p08_back); 
  p08->addChild(stripSet);


  // bottom
  texture_p08 = new SoTexture2;
  p08 -> addChild(texture_p08);
  texture_p08 -> filename.setValue("Texture/p08/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p08_indices_bottom)/sizeof(int32_t), p08_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p08_bottom)/sizeof(int), normalIndex_p08_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p08_bottom)/sizeof(int32_t), TexCoordIndex_p08_bottom); 
  p08->addChild(stripSet);

  p08 -> unrefNoDelete();

  return p08;
}
// end PANELAK 1