#include"buildings.h"

// VERTICES 
// body v prostoru jejich propojenim vytvarim model budovy 

static float p13_vertices[][3] = {
	-2, 0, -2.5f,  // 0
	 2, 0, -2.5f,  // 1
    -2, 2, -2.5f,  // 2
     2, 2, -2.5f,  // 3

	-1, 0, -1.5f,  // 4
     2, 0, -1.5f,  // 5
    -1, 2, -1.5f,  // 6
     2, 2, -1.5f,  // 7

	-1, 0, -0.5f,  // 8
	 2, 0, -0.5f,  // 9
    -1, 2, -0.5f,  // 10
     2, 2, -0.5f,  // 11

	-1, 0, 0.5f,  // 12
     2, 0, 0.5f,  // 13
    -1, 2, 0.5f,  // 14
     2, 2, 0.5f,  // 15

	-1, 0, 1.5f,  // 16
	 2, 0, 1.5f,  // 17
    -1, 2, 1.5f,  // 18
     2, 2, 1.5f,  // 19

	-2, 0, 2.5f,  // 20
     2, 0, 2.5f,  // 21
    -2, 2, 2.5f,  // 22
     2, 2, 2.5f,  // 23
};


// NORMALS
// normaly pro dobre osvetleni sten modelu budovy

static float p13_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z
	
};

static int32_t p13_indices_front_first[] = {0,1,2,3, -1};
static int32_t p13_indices_front_second[] = {8,9,10,11, -1};
static int32_t p13_indices_front_third[] = {16,17,18,19, -1};
static int32_t p13_indices_left[] = {0,2,20,22, -1};
static int32_t p13_indices_right_first[] = {1,3,5,7, -1};
static int32_t p13_indices_right_second[] = {4,6,8,10, -1};
static int32_t p13_indices_right_third[] = {9,11,13,15, -1};
static int32_t p13_indices_right_fourth[] = {12,14,16,18, -1};
static int32_t p13_indices_right_fifth[] = {17,19,21,23, -1};
static int32_t p13_indices_back_first[] = {4,5,6,7, -1};
static int32_t p13_indices_back_second[] = {12,13,14,15, -1};
static int32_t p13_indices_back_third[] = {20,21,22,23, -1};
static int32_t p13_indices_up_first[] = {3,7,2,6,22,18,23,19, -1};
static int32_t p13_indices_up_second[] = {10,11,14,15, -1};
static int32_t p13_indices_bottom_first[] = {1,5,0,4,20,16,21,17, -1};
static int32_t p13_indices_bottom_second[] = {8,9,12,13, -1};

static int normalIndex_p13_front_first[] = {5,5};   // -z  
static int normalIndex_p13_front_second[] = {5,5};   // -z
static int normalIndex_p13_front_third[] = {5,5};   // -z   
static int normalIndex_p13_left[] = {3,3};    // -x
static int normalIndex_p13_right_first[] = {0,0};   //  x
static int normalIndex_p13_right_second[] = {0,0};   //  x
static int normalIndex_p13_right_third[] = {0,0};   //  x
static int normalIndex_p13_right_fourth[] = {0,0};   //  x
static int normalIndex_p13_right_fifth[] = {0,0};   //  x
static int normalIndex_p13_back_first[] = {2,2};    //  z
static int normalIndex_p13_back_second[] = {2,2};    //  z
static int normalIndex_p13_back_third[] = {2,2};    //  z
static int normalIndex_p13_up_first[] = {1,1,1,1,1,1};      //  y  
static int normalIndex_p13_up_second[] = {1,1};      //  y
static int normalIndex_p13_bottom_first[] = {4,4,4,4,4,4};  // -y
static int normalIndex_p13_bottom_second[] = {4,4};  // -y

static int32_t TexCoordIndex_p13_front_first[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_front_second[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_front_third[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_up_first[] = {1,5,0,4,2,6,3,7, -1};
static int32_t TexCoordIndex_p13_up_second[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_left[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_right_first[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_right_second[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_right_third[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_right_fourth[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_right_fifth[] = {0,2,1,3, -1};
static int32_t TexCoordIndex_p13_back_first[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_back_second[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_back_third[] = {0,1,2,3, -1};
static int32_t TexCoordIndex_p13_bottom_first[] = {1,5,0,4,2,6,3,7, -1};
static int32_t TexCoordIndex_p13_bottom_second[] = {0,1,2,3, -1};

// PANELAK 1
// krychle ( cube pres FaceSet :) ) 
SoSeparator *make_p13_FaceSet(float x, float y, float z, float alfa)
{
  // 
  SoSeparator *p13 = new SoSeparator;
  p13 -> ref();

  // umisteni budovy
  SoTransform *transform = new SoTransform;
  transform->translation.setValue(x,y,z);
  p13->addChild(transform);

  // velikost modelu budovy 
  SoScale *scale = new SoScale;
  scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
  p13->addChild(scale);

  // rotace modelu budovy 
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  p13 -> addChild(myRotation);

  // normaly modelu budovy
  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, p13_normal);
  p13 -> addChild(myNormals); 

  // 
  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  p13 -> addChild(myNormalBinding);

  // propojeni bodu modelu budovy 
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(p13_vertices)/sizeof(float), p13_vertices);
  p13->addChild(coords);

  // 'vyrez textury (tvar 2D pro krychly potrebujeme ctverec bereme celou textuturu)' 
  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));

  texCoord->point.set1Value(4, SbVec2f(0.25f,0.2f));
  texCoord->point.set1Value(5, SbVec2f(1,0.2f));
  texCoord->point.set1Value(6, SbVec2f(0.25f,0.8f));
  texCoord->point.set1Value(7, SbVec2f(1,0.8f));
  p13->addChild(texCoord);

  // front_first
  SoTexture2 *texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_front_first)/sizeof(int32_t), p13_indices_front_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_front_first)/sizeof(int), normalIndex_p13_front_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_front_first)/sizeof(int32_t), TexCoordIndex_p13_front_first); 
  p13->addChild(stripSet);

  // front_second
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_front_second)/sizeof(int32_t), p13_indices_front_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_front_second)/sizeof(int), normalIndex_p13_front_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_front_second)/sizeof(int32_t), TexCoordIndex_p13_front_second); 
  p13->addChild(stripSet);

  // front_third
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_front_third)/sizeof(int32_t), p13_indices_front_third);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_front_third)/sizeof(int), normalIndex_p13_front_third);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_front_third)/sizeof(int32_t), TexCoordIndex_p13_front_third); 
  p13->addChild(stripSet);


  // up_first
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_up_first)/sizeof(int32_t), p13_indices_up_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_up_first)/sizeof(int), normalIndex_p13_up_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_up_first)/sizeof(int32_t), TexCoordIndex_p13_up_first); 
  p13->addChild(stripSet);

  // up_second
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_up_second)/sizeof(int32_t), p13_indices_up_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_up_second)/sizeof(int), normalIndex_p13_up_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_up_second)/sizeof(int32_t), TexCoordIndex_p13_up_second); 
  p13->addChild(stripSet);


  // left
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_left)/sizeof(int32_t), p13_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_left)/sizeof(int), normalIndex_p13_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_left)/sizeof(int32_t), TexCoordIndex_p13_left); 
  p13->addChild(stripSet);


  // right_first
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_right_first)/sizeof(int32_t), p13_indices_right_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_right_first)/sizeof(int), normalIndex_p13_right_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_right_first)/sizeof(int32_t), TexCoordIndex_p13_right_first); 
  p13->addChild(stripSet);

  // right_second
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_right_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_right_second)/sizeof(int32_t), p13_indices_right_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_right_second)/sizeof(int), normalIndex_p13_right_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_right_second)/sizeof(int32_t), TexCoordIndex_p13_right_second); 
  p13->addChild(stripSet);

  // right_third
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_right_third)/sizeof(int32_t), p13_indices_right_third);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_right_third)/sizeof(int), normalIndex_p13_right_third);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_right_third)/sizeof(int32_t), TexCoordIndex_p13_right_third); 
  p13->addChild(stripSet);

  // right_fourth
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_right_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_right_fourth)/sizeof(int32_t), p13_indices_right_fourth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_right_fourth)/sizeof(int), normalIndex_p13_right_fourth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_right_fourth)/sizeof(int32_t), TexCoordIndex_p13_right_fourth); 
  p13->addChild(stripSet);

  // right_fifth
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_right_fifth)/sizeof(int32_t), p13_indices_right_fifth);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_right_fifth)/sizeof(int), normalIndex_p13_right_fifth);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_right_fifth)/sizeof(int32_t), TexCoordIndex_p13_right_fifth); 
  p13->addChild(stripSet);

  
  // back_first
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_back_first)/sizeof(int32_t), p13_indices_back_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_back_first)/sizeof(int), normalIndex_p13_back_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_back_first)/sizeof(int32_t), TexCoordIndex_p13_back_first); 
  p13->addChild(stripSet);

  // back_second
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_back_second)/sizeof(int32_t), p13_indices_back_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_back_second)/sizeof(int), normalIndex_p13_back_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_back_second)/sizeof(int32_t), TexCoordIndex_p13_back_second); 
  p13->addChild(stripSet);

  // back_third
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_p13_in.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_back_third)/sizeof(int32_t), p13_indices_back_third);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_back_third)/sizeof(int), normalIndex_p13_back_third);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_back_third)/sizeof(int32_t), TexCoordIndex_p13_back_third); 
  p13->addChild(stripSet);


  // bottom_first
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_bottom_first)/sizeof(int32_t), p13_indices_bottom_first);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_bottom_first)/sizeof(int), normalIndex_p13_bottom_first);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_bottom_first)/sizeof(int32_t), TexCoordIndex_p13_bottom_first); 
  p13->addChild(stripSet);

  // bottom_second
  texture_p13 = new SoTexture2;
  p13 -> addChild(texture_p13);
  texture_p13 -> filename.setValue("Texture/p13/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(p13_indices_bottom_second)/sizeof(int32_t), p13_indices_bottom_second);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_p13_bottom_second)/sizeof(int), normalIndex_p13_bottom_second);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_p13_bottom_second)/sizeof(int32_t), TexCoordIndex_p13_bottom_second); 
  p13->addChild(stripSet);

  p13 -> unrefNoDelete();

  return p13;
}
// end PANELAK 1