#include"buildings.h"

static float s08_vertices[][3] = {
	-0.5f, 0, -0.5f,  // 0
	 0.5f, 0, -0.5f,  // 1
     0.5f, 2, -0.5f,  // 2
    -0.5f, 2, -0.5f,  // 3

     0, 2.5, 0,  // 4

	 0.5f, 2, 0.5f,  // 5
    -0.5f, 2, 0.5f,  // 6
    -0.5f, 0, 0.5f,  // 7
     0.5f, 0, 0.5f,  // 8
};

static float s08_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z

	 0.70710f,0.70710f,0, // 6 left_up 45 sklon strechy 
	-0.70710f,0.70710f,0, // 7 right_up 45 sklon strechy 
	 0,0.70710f,0.70710f, // 8 back_up 45 sklon strechy 
	 0,0.70710f,-0.70710f,// 9 front_up 45 sklon strechy 
};

static int32_t s08_indices_front[] = { 1,0,2,3, -1 };
static int32_t s08_indices_front_up[] = { 2,3,4, -1 };
static int32_t s08_indices_left[] = { 1,8,2,5, -1 };
static int32_t s08_indices_left_up[] = { 2,5,4, -1 };
static int32_t s08_indices_right[] = { 0,7,3,6, -1 };
static int32_t s08_indices_right_up[] = { 3,6,4, -1 };
static int32_t s08_indices_back[] = { 7,8,6,5, -1 };
static int32_t s08_indices_back_up[] = { 6,5,4, -1 };
static int32_t s08_indices_bottom[] = { 0,1,7,8, -1 };
 
static int normalIndex_s08_front[] = { 5, 5 };
static int normalIndex_s08_front_up[] = { 9 };
static int normalIndex_s08_left[] = { 0, 0 };
static int normalIndex_s08_left_up[] = { 6 };
static int normalIndex_s08_right[] = { 3, 3 };
static int normalIndex_s08_right_up[] = { 7 };
static int normalIndex_s08_back[] = { 2, 2 };
static int normalIndex_s08_back_up[] = { 8 };
static int normalIndex_s08_bottom[] = { 4, 4 };

static int32_t TexCoordIndex_s08_front[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s08_front_up[] = { 0,1,4, -1 };
static int32_t TexCoordIndex_s08_left[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s08_left_up[] = { 0,1,4, -1 };
static int32_t TexCoordIndex_s08_right[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s08_right_up[] = { 0,1,4, -1 };
static int32_t TexCoordIndex_s08_back[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s08_back_up[] = { 0,1,4, -1 };
static int32_t TexCoordIndex_s08_bottom[] = { 0,1,2,3, -1 };

SoSeparator *make_s08_FaceSet(float x, float y, float z, float alfa)
{
	SoSeparator *s08 = new SoSeparator();
	s08 -> ref();

    SoTransform *transform = new SoTransform;
    transform->translation.setValue(x,y,z);
    s08->addChild(transform);

    SoScale *scale = new SoScale;
    scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
    s08->addChild(scale);

  // rotace modelu budovy
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  s08 -> addChild(myRotation);

  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 10, s08_normal);
  s08 -> addChild(myNormals); 

  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  s08 -> addChild(myNormalBinding);
  

  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(s08_vertices)/sizeof(float), s08_vertices);
  s08->addChild(coords);

  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  texCoord->point.set1Value(4, SbVec2f(0.5,1));
  s08->addChild(texCoord);

  // front
  SoTexture2 *texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_front)/sizeof(int32_t), s08_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_front)/sizeof(int), normalIndex_s08_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_front)/sizeof(int32_t), TexCoordIndex_s08_front); 
  s08->addChild(stripSet);


  // front_up
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_front_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_front_up)/sizeof(int32_t), s08_indices_front_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_front_up)/sizeof(int), normalIndex_s08_front_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_front_up)/sizeof(int32_t), TexCoordIndex_s08_front_up); 
  s08->addChild(stripSet);


  // left
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_left)/sizeof(int32_t), s08_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_left)/sizeof(int), normalIndex_s08_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_left)/sizeof(int32_t), TexCoordIndex_s08_left); 
  s08->addChild(stripSet);


  // left_up
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_left_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_left_up)/sizeof(int32_t), s08_indices_left_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_left_up)/sizeof(int), normalIndex_s08_left_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_left_up)/sizeof(int32_t), TexCoordIndex_s08_left_up); 
  s08->addChild(stripSet);


  // right
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_right)/sizeof(int32_t), s08_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_right)/sizeof(int), normalIndex_s08_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_right)/sizeof(int32_t), TexCoordIndex_s08_right); 
  s08->addChild(stripSet);


  // right_up
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_right_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_right_up)/sizeof(int32_t), s08_indices_right_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_right_up)/sizeof(int), normalIndex_s08_right_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_right_up)/sizeof(int32_t), TexCoordIndex_s08_right_up); 
  s08->addChild(stripSet);

  
  // back
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_back)/sizeof(int32_t), s08_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_back)/sizeof(int), normalIndex_s08_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_back)/sizeof(int32_t), TexCoordIndex_s08_back); 
  s08->addChild(stripSet);


  // back_up
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_s08_back_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_back_up)/sizeof(int32_t), s08_indices_back_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_back_up)/sizeof(int), normalIndex_s08_back_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_back_up)/sizeof(int32_t), TexCoordIndex_s08_back_up); 
  s08->addChild(stripSet);


  // bottom
  texture_s08 = new SoTexture2;
  s08 -> addChild(texture_s08);
  texture_s08 -> filename.setValue("Texture/s08/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s08_indices_bottom)/sizeof(int32_t), s08_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s08_bottom)/sizeof(int), normalIndex_s08_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s08_bottom)/sizeof(int32_t), TexCoordIndex_s08_bottom); 
  s08->addChild(stripSet); 


	s08 -> unrefNoDelete();
	return s08;
}
