#include"buildings.h"

static float s14_vertices[][3] = {
	-0.5f, 0, -0.5f,  // 0
	0.5f, 0, -0.5f,  // 1
    0.5f, 1, -0.5f,  // 2
    -0.5f, 1, -0.5f,  // 3

    -0.5f, 1.5, 0.5f,  // 4
	0.5f, 1.5, 0.5f,  // 5

	0.5f, 1, 0.5f,  // 6
    -0.5f, 1, 0.5f,  // 7
    -0.5f, 0, 0.5f,  // 8
    0.5f, 0, 0.5f,  // 9


};

static float s14_normal[][3] = {

	1, 0, 0, // 0 x 
    0, 1, 0, // 1 y
    0, 0, 1, // 2 z
 
	-1, 0, 0, // 3 -x
    0, -1, 0, // 4 -y
    0, 0, -1, // 5 -z

    0,0.89442f,-0.44721f  // 6 front_up sklon strechy
};

static int32_t s14_indices_front[] = { 1,0,2,3, -1 };
static int32_t s14_indices_up[] = { 2,3,5,4, -1 };
static int32_t s14_indices_left[] = { 5,2,6,1,9, -1 };
static int32_t s14_indices_right[] = { 4,3,7,0,8, -1 };
static int32_t s14_indices_back[] = { 4,5,8,9, -1 };
static int32_t s14_indices_bottom[] = { 0,1,8,9, -1 };

static int normalIndex_s14_front[] = { 5, 5 };
static int normalIndex_s14_up[] = { 6, 6 };
static int normalIndex_s14_left[] = { 0, 0, 0 };
static int normalIndex_s14_right[] = { 3, 3, 3 };
static int normalIndex_s14_back[] = { 2, 2 };
static int normalIndex_s14_bottom[] = { 4, 4 };

static int32_t TexCoordIndex_s14_front[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s14_up[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s14_left[] = { 3,4,5,0,1, -1 };
static int32_t TexCoordIndex_s14_right[] = { 3,4,5,0,1, -1 };
static int32_t TexCoordIndex_s14_back[] = { 0,1,2,3, -1 };
static int32_t TexCoordIndex_s14_bottom[] = { 0,1,2,3, -1 };


SoSeparator *make_s14_FaceSet(float x, float y, float z, float alfa)
{
	SoSeparator *s14 = new SoSeparator();
	s14 -> ref();

    SoTransform *transform = new SoTransform;
    transform->translation.setValue(x,y,z);
    s14->addChild(transform);

    SoScale *scale = new SoScale;
    scale->scaleFactor.setValue(SCALE_X,SCALE_Y,SCALE_Z);
    s14->addChild(scale);

  // rotace modelu budovy
  SoRotationXYZ *myRotation = new SoRotationXYZ;     
  myRotation -> angle = alfa;
  myRotation -> axis = SoRotationXYZ::Y;
  s14 -> addChild(myRotation);

  SoNormal *myNormals = new SoNormal;
  myNormals -> vector.setValues(0, 11, s14_normal);
  s14 -> addChild(myNormals); 

  SoNormalBinding *myNormalBinding = new SoNormalBinding;
  myNormalBinding -> value = SoNormalBinding::PER_FACE_INDEXED;
  s14 -> addChild(myNormalBinding);
  
  SoCoordinate3 *coords = new SoCoordinate3;
  coords->point.setValues(0, sizeof(s14_vertices)/sizeof(float), s14_vertices);
  s14->addChild(coords);

  SoTextureCoordinate2 *texCoord = new SoTextureCoordinate2;
  texCoord->point.set1Value(0, SbVec2f(0,0));
  texCoord->point.set1Value(1, SbVec2f(1,0));
  texCoord->point.set1Value(2, SbVec2f(0,1));
  texCoord->point.set1Value(3, SbVec2f(1,1));
  texCoord->point.set1Value(4, SbVec2f(0,0.6666f));
  texCoord->point.set1Value(5, SbVec2f(1,0.6666f));

  s14->addChild(texCoord);

  // front
  SoTexture2 *texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_s14_front.PNG");

  SoIndexedTriangleStripSet *stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_front)/sizeof(int32_t), s14_indices_front);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_front)/sizeof(int), normalIndex_s14_front);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_front)/sizeof(int32_t), TexCoordIndex_s14_front); 
  s14->addChild(stripSet);


  // up
  texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_s14_up.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_up)/sizeof(int32_t), s14_indices_up);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_up)/sizeof(int), normalIndex_s14_up);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_up)/sizeof(int32_t), TexCoordIndex_s14_up); 
  s14->addChild(stripSet);


  // left
  texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_s14_left.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_left)/sizeof(int32_t), s14_indices_left);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_left)/sizeof(int), normalIndex_s14_left);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_left)/sizeof(int32_t), TexCoordIndex_s14_left); 
  s14->addChild(stripSet);


  // right
  texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_s14_right.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_right)/sizeof(int32_t), s14_indices_right);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_right)/sizeof(int), normalIndex_s14_right);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_right)/sizeof(int32_t), TexCoordIndex_s14_right); 
  s14->addChild(stripSet);

  
  // back
  texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_s14_back.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_back)/sizeof(int32_t), s14_indices_back);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_back)/sizeof(int), normalIndex_s14_back);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_back)/sizeof(int32_t), TexCoordIndex_s14_back); 
  s14->addChild(stripSet);


  // bottom
  texture_s14 = new SoTexture2;
  s14 -> addChild(texture_s14);
  texture_s14 -> filename.setValue("Texture/s14/texture_bottom.PNG");

  stripSet = new SoIndexedTriangleStripSet;
  stripSet->coordIndex.setValues(0, sizeof(s14_indices_bottom)/sizeof(int32_t), s14_indices_bottom);
  stripSet->normalIndex.setValues(0, sizeof(normalIndex_s14_bottom)/sizeof(int), normalIndex_s14_bottom);
  stripSet->textureCoordIndex.setValues(0, sizeof(TexCoordIndex_s14_bottom)/sizeof(int32_t), TexCoordIndex_s14_bottom); 
  s14->addChild(stripSet);
 


	s14 -> unrefNoDelete();
	return s14;
}
